<?php
define('F4GIFT_VERSION', '1.11.2');

/*
Plugin Name: Factor4 Gift Rewards
Plugin URI: https://factor4gift.com/WooCommerce-Plugin-Information
Description: Increase sales and improve customer with Factor4 Gift card and Loyalty program.
Version: 1.11.2
Author: Factor4
Author URI: https://factor4gift.com
Stable tag: 1.6

History:
	2019-09-20	1.6		Added Logging for no currencies error
	2019-09-23	1.7		More Logging
	2019-09-26	1.8		Corrected handling of errorMessage when no soap fault in getBalances (Inquiry)
	2019-09-27	1.9		Added Error Styling to error message for (At least for the getBalances/Inquiry)
	2019-10-03	1.10	Reworked logic for saving copy of the request to use error_log to remove need to write to disk.
						Added more logging to get more information about where were are getting the errors.
	2019-10-29	1.11	Corrected root cause of issue with PHP V7

Client# 		999
		4114 	(From Sample Code)
Location#	323444
		437423	(From Sample Code)
		73335
Terminal Id	1
		99  
IntegrationUserName:	loc323444	Pass:	wordpress123		(Given)
		loc437423	Pass:	sFsnoZLuCjstmZ		(From Sample Code)

	Initiator ID: 		1000	
Initiator Password: 	2000
	Account:
account id:	988295367055586	Pin:	398846

Card# 
Woo Commerce Plug In 1 988295367055586	Pin:	398846
Ronn Black
rblack@btsoft.org
Test1234
Phone:	4153789868
2 Woo Commerce Plug In 2 988295362072734 
3 Woo Commerce Plug In 3 988295374317048 
4 Woo Commerce Plug In 4 988295346224394 
5 Woo Commerce Plug In 5 988295353533229

*/

error_reporting( E_ERROR  );
//ini_set('display_errors', 'On');
error_log('factor4gift: Initializing v' . F4GIFT_VERSION);


// core initiation
if( !class_Exists('vooMainStartGift') ){
	class vooMainStartGift{
		var $locale;
		function __construct( $locale, $includes, $path ){
			$this->locale = $locale;
			
			// include files
			foreach( $includes as $single_path ){
				include( $path.$single_path );				
			}
			// calling localization
			add_action('plugins_loaded', array( $this, 'myplugin_init' ) );
			
			// add settings page
			add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), array( $this, 'add_action_links' ) );
		}
		function myplugin_init() {
		 $plugin_dir = basename(dirname(__FILE__));
		 load_plugin_textdomain( $this->locale , false, $plugin_dir );
		}
		function add_action_links ( $links ) {
			$mylinks = array(
		 '<a href="' . admin_url( 'options-general.php?page=wrw_settings' ) . '">Settings</a>',
		 );
			return array_merge( $links, $mylinks );
		}
	}
	
	
}


// initiate main class
new vooMainStartGift('wrw', array(
	'modules/scripts.php',
	//'modules/meta_box.php',
	'modules/hooks.php',
	'modules/settings.php',
	'modules/functions.php',
	'modules/ajax.php',
), dirname(__FILE__).'/' );

 



#include('modules/functions.php');
#include('modules/shortcodes.php');
#include('modules/settings.php');
#include('modules/meta_box.php');
#include('modules/widgets.php');
#include('modules/hooks.php');
#include('modules/cpt.php');
#include('modules/scripts.php');
#include('modules/ajax.php');
 
?>