<?php 
class initiateCardVariables{
	
	var $settings;

	public function __construct(   ){
		
		$this->settings = get_option('wrw_options');
		//init data
		$this->initiate_data();
	}
	// initiate constants
	function initiate_data(){
		define('SPARKBASE_TRANSACTION_WSDL', $this->settings['api_url']);
		
		// 'https://trans.api.factor4gift.com/v4/transaction?wsdl'
		
		//define('FACTOR4GIFT_TRANSACTION_WSDL', 		  'https://trans.api.factor4gift.com/v4/transaction?wsdl');
		define('LOCALE_ID', 'EN'); // Host default is "EN" when none is provided
		define('SYSTEM_ID', 'SB');
		define('CLIENT_ID', $this->settings['clientId'] ); 

		// Values specific to a merchant location:
		define('LOCATION_ID', $this->settings['LocationId'] );
		define('INTEGRATION_USER_NAME', $this->settings['IntegrationUserName'] ); // A.k.a. Integration Auth
		define('INTEGRATION_PASSWORD', $this->settings['IntegrationPassword'] );
		// When integrating with multiple, physical registers/lanes this value should
		//  change to match those (consider changing it to a variable)
		define('TERMINAL_ID', $this->settings['TerminalId'] );

		// May vary by transaction (if so they should probably be changed to variables)
		// These are optional
		define('INITIATOR_TYPE', $this->settings['InitiatorType'] ); // Merchant (E)mployee, Client (U)ser, (C)ustomer
		define('INITIATOR_ID', $this->settings['InitiatorId'] ); // Employee's POS id, user or customer e-mail
		// Employee's POS password (usually 4-10 digits) or user/customer password as
		//  SHA-256 hash (salted with e-mail as prefix)
		define('INITIATOR_PASSWORD', $this->settings['InitiatorPassword'] );
		// The path to the request batch storage file
		define('REQ_BAT_PATH', dirname(__FILE__) . '/req-bat.txt');
		
		require_once(dirname(__FILE__) . '/inc/api/SparkbaseTransV4Classes.php');
		require_once(dirname(__FILE__) . '/inc/api/SparkbaseTransV4Util.php');
	}
}

 
class pointsMessaging{
	
	var $options;
	var $request_error;
	var $user_points;
	var $message;
	
	var $error_message;
	
	var $coupon_amount;
	
	var $card_type; 
	var $user_id;
	var $card_number;
	var $card_pin;
	var $card_subtotal;
	
	public function __construct( $card_number = null, $card_pin = null, $card_type = null ){
		
		global $current_user;
		
		$this->user_id = $current_user->ID;
	 
		new initiateCardVariables();
	 
		if( !$card_type ){
			$this->card_type = get_user_meta( $this->user_id, 'card_type', true );
		}else{
			$this->card_type = $card_type;
		}
	 
		if( !$card_number ){
			$this->card_number = get_user_meta( $this->user_id, 'card_number', true );
		}else{
			$this->card_number = $card_number;
		}
		
		if( !$card_pin ){
			$this->card_pin = get_user_meta( $this->user_id, 'card_pin', true );
		}else{
			$this->card_pin = $card_pin;
		}

 
		// output message 
		add_action('woocommerce_before_checkout_form', array( $this, 'cart_message_points' ), 10, 0 );
		
		// save card data
		add_action('woocommerce_checkout_update_order_meta', array( $this, 'add_card_data_to_order' ), 10, 2 );
		
	 
		// apply points / money spending
		if( isset($_POST['spending_amount'] ) ){
			//add_action('tempate_redirect', array( $this, 'apply_money_to_card' ), 10, 2 );
			$this->apply_money_to_card();
		}
	}
 
	// add card data to order
	function add_card_data_to_order( $order_id  ){
		

		if( WC()->session->get( 'card_type') )
		update_post_meta( $order_id, 'card_type', WC()->session->get( 'card_type') );
	
		if( WC()->session->get( 'card_number') )
		update_post_meta( $order_id, 'card_number', WC()->session->get( 'card_number') );
	
		if( WC()->session->get( 'card_pin') )
		update_post_meta( $order_id, 'card_pin', WC()->session->get( 'card_pin') );
 
			 
		
	}
	
	function apply_money_to_card(){
		
	 
		global $woocommerce;
		$card_type = $_POST['card_type'];
		$card_number = $_POST['card_number'];
		$card_pin = $_POST['card_pin'];
		$card_subtotal = (float)$_POST['card_subtotal'];
		$user_amount = $spending_amount = $_POST['spending_amount'];
		
	 
		if( $card_type ){
	 
		// get points amount
		$points = (float)( $user_amount );
		
		$this->coupon_amount = $points;
		
		// smaller amount fix
		$card_total = $card_subtotal;

		if( $this->coupon_amount > $card_total ){
			$user_amount = $card_total;
			$points = (float)( $user_amount );
			$this->coupon_amount = $points;
		}
		
		$object = new pointsManipulations( 'GiftRedemption', false, $points  );
		
		$object->card_type = $card_type;
		$object->card_number = $card_number;
		$object->card_pin = $card_pin;
		
		$object->make_request();
 
		if( $object->request_error == 0 ){
			$coupon_code = 'F4_Reward_Coupon_'.substr($object->card_number, -4).'_'.substr( md5( time() ), 0, 5  );
			
			if( $object->card_type == 'loyalty' ){
				$coupon_content = 'loyalty_card_type';
			}
			if( $object->card_type == 'gift' ){
				$coupon_content = 'gift_card_type';
			}
			
			$args = array(
				'post_type' => 'shop_coupon',
				'post_content' => $coupon_content,
				'post_status' => 'publish',
				'post_name' => $coupon_code,
				'post_title' => $coupon_code,
			);
			$new_id = wp_insert_post( $args );
			update_post_meta( $new_id, 'coupon_amount', $user_amount);
			update_post_meta( $new_id, 'discount_type', "fixed_cart");
			update_post_meta( $new_id, 'individual_use', "no");
			update_post_meta( $new_id, 'usage_limit', "1");
			update_post_meta( $new_id, 'usage_limit_per_user', "0");
			update_post_meta( $new_id, 'limit_usage_to_x_items', "0");
			update_post_meta( $new_id, 'usage_count', "0");
			update_post_meta( $new_id, 'free_shipping', "no");
			
			update_post_meta( $new_id, 'card_type', $object->card_type);
			update_post_meta( $new_id, 'card_number', $object->card_number);
			update_post_meta( $new_id, 'card_pin', $object->card_pin);
			
			
			update_post_meta( $new_id, 'transactionId', $object->transactionId );
			update_post_meta( $new_id, 'approvalCode', $object->approvalCode );
			
		 
			WC()->cart->add_discount( $coupon_code );
			apply_filters( 'woocommerce_coupon_message', array( $this, 'change_coupon_message' ), 1, 1 );
			
		}else{
			$this->error_message = $object->request_error_message;
		}

		} 
		
	
	}
	function change_coupon_message( $message ){
		$message = __('A coupon in the amount of $'.$this->coupon_amount.' has been applied to your purchase.', 'wrw');
		return $message;
	}
 
	function check_coupon_applied(){
		$all_coupons = WC()->cart->applied_coupons;
		if( count($all_coupons) > 0 ){
			foreach( $all_coupons as $single_coupon ){
				$args = array(
					'post_title' => $single_coupon,
					'post_type' => 'shop_coupon',
					
				);
				$all_posts = get_posts( $args );
				$content = $all_posts[0]->post_content;
				if( $content == 'loyalty_card_type' || $content == 'gift_card_type' ){
					
					$this->coupon_amount = get_post_meta( $all_posts[0]->ID,  'coupon_amount', true );
					
					return true;
				}
			}
		}
		return false;
	}
	
	function cart_message_points(){
		
		// checking if coupon alread applied
		if( $this->check_coupon_applied() ){
			echo __('<div class="tw-bs4"><div class="alert alert-success">A coupon in the amount of $'.$this->coupon_amount.' has been applied to your purchase.</div></div>', 'wrw');
			return true;
		}
		/*
		else{
			echo '<div class="tw-bs4"><div class="alert alert-warning">'.$this->error_message.'</div></div>';
			return true;
		}
		*/
		
		
		if( is_user_logged_in() ){
			if( $this->card_number && $this->card_number != '' && $this->card_pin && $this->card_pin != '' ){
				// init session with card credentials
				WC()->session->set( 'card_type', $this->card_type );
				WC()->session->set( 'card_number', $this->card_number );
				WC()->session->set( 'card_pin', $this->card_pin );
				
		
				$spending_form = $this->generate_spending_form();
				if( $this->request_error == 1 ){
					echo __('<div class="tw-bs4"><div class="alert alert-danger">'.$this->error_message.'</div></div>', 'wrw');
				}else{
					//conversion
					/*
					$money = $this->user_points / 5;
					$money = money_format( $money, 2 );
					echo '<div class="tw-bs4"><div class="alert alert-success">Current points: <span id="current_points">'.$this->user_points.'</span> equal to: <span id="current_money">'.$money.'</span>
					<br/>
					Conversion rate: 1:5
					<br/>
					Amount you want to use:
					<input id="money_amount" max="'.$money.'" data-max="'.$money.'" />
					<button type="button" class="btn btn-success" id="convert_money" >Get Discount</button>
					<div id="status_block"></div>
					</div></div>';
					*/
					echo $spending_form;
				}
			}else{
				echo '<div class="tw-bs4"><div class="alert alert-warning">You need to enter your card credentials to count your points. You can do this <a href="'.get_permalink( get_option('woocommerce_myaccount_page_id') ).'/edit-account/#card_number">here</a></div></div>';
				$this->show_card_form();
			}	
		}else{
			echo '<div class="tw-bs4"><div class="alert alert-warning">
			If you have a loyalty or gift card you may enter it below.
			Click <a href="'.get_permalink( get_option('woocommerce_myaccount_page_id') ).'">Here</a> to login or Click <a href="'.get_permalink( get_option('woocommerce_myaccount_page_id') ).'/edit-account/#card_number">here</a> to register your card to save time in the future.
			</div></div>';
			$this->show_card_form();
		}
		
		
		
	}
	
	function generate_spending_form(){
		error_log('factor4gift: generate_spending_form()');
		$out = '';
		if( $this->card_type == 'gift' || $this->card_type == 'loyalty' ){
			$this->get_current_usd();
			
			if( $this->request_error == 1 ){
				$out = '<div class="alert alert-warning">' . $this->error_message . '</div>';
				return $out;
			}
			
		}
		 
		$out .= '<div class="tw-bs4">
		<form method="POST" action="" id="spend_money" >
		';
		if( $this->card_type == 'gift' || $this->card_type == 'loyalty' ){
			$out  .= '<div class="alert alert-success">You have $'.$this->user_points.' available. ';
		}
		if( $this->card_type == 'gift' || $this->card_type == 'loyalty' ){
			$out .= '<div class="">'.__('Enter the amount you would like to apply to the current purchase.', 'wrw').'</div>';
		}
					

		$out .=  '
		<div >
			<input type="hidden" name="card_subtotal"  value="'.WC()->cart->get_subtotal().'" />
			<input type="hidden" name="card_type"  value="'.$this->card_type.'" />
			<input type="hidden" name="card_number"  value="'.$this->card_number.'" />
			<input type="hidden" name="card_pin" value="'.$this->card_pin.'" />
		
			<input name="spending_amount" id="spending_amount" max="'.$this->user_points.'" data-max="'.$this->user_points.'" />
			<button type="submit" class="btn btn-success" id="convert_money" >'.__('Submit', 'wrw').'</button>
		</div>
		<div id="status_block"></div>
		</div>
		</form>
		</div>';
		return $out;
	}
	
	function show_card_form(){
		error_log('factor4gift: show_card_form()...');
	
 
		//conversion		
		echo '
		<div class="tw-bs4">
		<form id="card_submit_form">
		
			<div class="loader_overlap" style="background-image:url('.plugins_url( '/images/ajax-loader.gif', __FILE__ ).');"></div>
		
		  <div class="form-group">
			<label for="exampleInputEmail1">'.__('Card Type', 'wrw').'</label>
			<select  id="card_type" class="form-control" name="card_type">
				<option value="loyalty">'.__('Loyalty', 'wrw').'
				<option value="gift">'.__('Gift Card', 'wrw').'
			</select>
		  </div>
		  <div class="form-group">
			<label for="exampleInputEmail1">'.__('Card Number', 'wrw').'</label>
			<input type="text" class="form-control" id="card_number"  value="" aria-describedby="emailHelp" placeholder="'.__('Enter card number', 'wrw').'">
		  </div>
		  <div class="form-group">
			<label for="exampleInputPassword1">'.__('PIN', 'wrw').'</label>
			<input type="password" class="form-control" id="card_pin" value=""  placeholder="">
		  </div>
		  
		  <button type="submit" class="btn btn-primary">'.__('Submit', 'wrw').'</button>
		  <div id="status_output"></div>
		</form>
		<div id="next_step_form"></div>
		</div>';
		
	
	}
	
	function get_current_points(){
		$array = array(
			'method' => 'Inquiry',
			'accountId' => $this->card_number,
			'pin' => $this->card_pin,
			'entryType' => 'K',
		);
	 
		$_POST = $array;
		 	 
		try {				
			$response = SendRequest();	
 
			if( count( $response->balances->balance ) ){
				foreach( $response->balances->balance as $single_currency ){
					if( $single_currency->valueCode == 'Points' ){
						$this->user_points = $single_currency->amount;
					}
				}
				$this->request_error = 0;
			} 	
			if( isset($response->errorMessage ) ){
				$this->request_error = 1;
				$this->message = 'card_issue';
			}
			
		}
		catch(SoapFault $soapFault) {
			// Log the error
			error_log('factor4gift: get_current_points()...SoapFault ' . var_dump($soapFault));
 
			$fault = str_replace($_SERVER['DOCUMENT_ROOT'], '', $soapFault);
		 	
			$this->request_error = 1;
		}
	}
	function get_current_usd(){
		$array = array(
			'method' => 'Inquiry',
			'accountId' => $this->card_number,
			'pin' => $this->card_pin,
			'entryType' => 'K',
		);
		$_POST = $array;
		 		 		 
		try {				
			$response = SendRequest();
			error_log('factor4gift: getBalances (Inquiry)... Processing Response ' . json_encode($response) );
	 
			if( count( $response->balances->balance ) ){
				$idx = 1;
				error_log('factor4gift: woocommerce Currency [' . get_woocommerce_currency() . ']');
				foreach( $response->balances->balance as $single_currency ){
					error_log('factor4gift: single_currency (' . $idx++ . ') ' . json_encode($single_currency));	
					if( $single_currency->valueCode == get_woocommerce_currency() ){
						$this->user_points = $single_currency->amount;
					}
				}
				$this->request_error = 0;
				
				if( $this->user_points == '' ){
					$this->request_error = 1;
					$this->error_message = __('No currencies found. Please, check if you set up correct currency');
					error_log('factor4gift: No Currencies found. ' . var_dump($response));	
				}
				
			} 	
			if( isset( $response->errorMessage ) ){
				$this->request_error = 1;
				$this->error_message = $response->errorMessage->briefMessage;
				error_log('factor4gift: getBalances (Inquiry)... Error' . var_dump($response->errorMessage) );
			}
			
		}
		catch(SoapFault $soapFault) {
			// Log the error
			error_log('factor4gift: get_current_usd()...SoapFault ' . var_dump($soapFault));
			$fault = str_replace($_SERVER['DOCUMENT_ROOT'], '', $soapFault);		 	
			$this->request_error = 1;
		}
	}
}

class giftCard{
	
	public function __construct(){

		add_action('woocommerce_before_checkout_form', array( $this, 'gift_input_field' ), 10, 0 );
	}

	function gift_input_field(){
		//conversion		
		echo '
		<div class="tw-bs4">
		<form id="check_gift_card">
		  <div class="form-group">
			<label for="exampleInputEmail1">'.__('Card Number', 'wrw').'</label>
			<input type="text" class="form-control" id="card_number" aria-describedby="emailHelp" placeholder="'.__('Enter card number', 'wrw').'">
		  </div>
		  <div class="form-group">
			<label for="exampleInputPassword1">'.__('PIN', 'wrw').'</label>
			<input type="password" class="form-control" id="card_pin" placeholder="">
		  </div>
		  
		  <button type="submit" class="btn btn-primary">'.__('Submit', 'wrw').'</button>
		</form>
		</div>';
		
	}
 
}

add_Action('init', 'cart_check_message');
function cart_check_message(){
	global $woocommerce;
	new pointsMessaging();
	//new giftCard();
	
}

class pointsManipulations{
	var $options;
	var $action;
	var $order_id;
	var $request_error;
	var $points;
	
	var $request_type;
	
	var $transactionId;
	var $approvalCode;
	
	var $request_error_message;
	
	var $card_type;	
	var $card_number;	
	var $card_pin;	
	
	public function __construct( $action = false, $order_id = false, $points = null  ){
		$this->action = $action;
		$this->order_id = $order_id;
		$this->points = $points;
		new initiateCardVariables();			
	}
	
	
	
	function  remove_order_coupons( $order_id ){
		// check if order made with loyalty cxard
		$card_type = get_post_type( $order_id, 'card_type', true );
		$card_number = get_post_type( $order_id, 'card_number', true );
		$card_pin = get_post_type( $order_id, 'card_pin', true );
		
		$order = new WC_Order( $order_id );
		$coupons = $order->get_used_coupons();
		

		if( count($coupons) > 0 ){
			foreach( $coupons as $single_coupon_code ){
				$this->refund_coupon( wc_get_coupon_id_by_code($single_coupon_code ) );
			}
		}
		 
		 
	}
	
 
	
	public static function  drop_unused_coupons(){
		global $wpdb;
		
		$date = time() - 24*60*60;
		//  AND post_date  < ".date( '"Y-m-d H:i:s"', $date )."
		$all_unused_coupons = $wpdb->get_results("SELECT ID, post_title FROM {$wpdb->prefix}posts WHERE post_type = 'shop_coupon' AND post_content = 'loyalty_card_type'  AND post_date  < ".date( '"Y-m-d H:i:s"', $date )."  AND post_title NOT IN (SELECT order_item_name FROM {$wpdb->prefix}woocommerce_order_items WHERE order_item_type = 'coupon'  ) ");
		 
		foreach( $all_unused_coupons as $single_coupon ){
			pointsManipulations::refund_coupon( $single_coupon->ID );					
			wp_Delete_post( $single_coupon->ID, true );
			
		}
	}
	
	
	function refund_loyalty_points(){
		
	}
	
	function refund_coupon( $coupon_id ){
		 
		 
	 
			$coupon_points = get_post_meta( $coupon_id, 'coupon_amount', true );
						
			$object = new pointsManipulations( 'GiftIssuance', false, $coupon_points );		
			$object->card_type = get_post_meta( $coupon_id, 'card_type', true );
			$object->card_number = get_post_meta( $coupon_id, 'card_number', true );
			$object->card_pin = get_post_meta( $coupon_id, 'card_pin', true );
			//$object->transactionId = get_post_meta( $coupon_id, 'transactionId', true );
		 
			$object->make_request();	
			
			return $object->request_error;
		
	}
	
	
	function get_order_points(){
		$order = new WC_Order( $this->order_id );
		/*
		$all_summ = 0;
		if( count($order->get_items()) )
		foreach ($order->get_items() as $item_id => $item_data) { 
			$all_summ = $all_summ + (int)get_post_meta( $item_data->get_product_id(), 'product_points', true );
		}
		*/
		$all_summ = $order->get_total();
		return (float)$all_summ;
	}
	
	
 
	
	
	function make_request(){
		// initiate POST	
		if( $this->order_id ){
			$order_points = $this->get_order_points();
		}
		if( $this->points ){
			$order_points = $this->points;
		}
 
		########################
		if( $this->action == 'LoyaltyIssuance' ){
			$array = array(
				'method' => 'LoyaltyIssuance',
				'accountId' => $this->card_number,
				'pin' => $this->card_pin,
				'entryType' => 'K',
				'valueCode' => 'Points',
				'enteredAmount' => $order_points,
			);
			$_POST = $array;
			$this->inner_make_call();
		}
		if( $this->action == 'GiftRedemption' ){
			$array = array(
					'method' => 'GiftRedemption',
					'accountId' => $this->card_number,
					'pin' => $this->card_pin,
					'entryType' => 'K',
					'valueCode' => get_woocommerce_currency(),
					'enteredAmount' => $order_points,
				);
			$_POST = $array;
			$this->inner_make_call();
		}
		if( $this->action == 'GiftIssuance' ){
			$array = array(
					'method' => 'GiftIssuance',
					'accountId' => $this->card_number,
					'pin' => $this->card_pin,
					'entryType' => 'K',
					'valueCode' => get_woocommerce_currency(),
					'enteredAmount' => $order_points,
				);
			$_POST = $array;
			$this->inner_make_call();
		}
		if( $this->action == 'VoidTransaction' ){
			$array = array(
				'method' => 'VoidTransaction',
				'accountId' => $this->card_number,
				'pin' => $this->card_pin,
				'entryType' => 'K',			
				'transactionId' => $this->transactionId,
			);
		 
			$_POST = $array;
			$this->inner_make_call();
		}
		
	}
	function inner_make_call(){
		try {				
			$response = SendRequest();	
			if( isset($response->errorMessage) ){
				$this->request_error_message = $response->errorMessage->inDepthMessage;
				$this->request_error = 1;
			}else{
				$this->transactionId = $response->identification->transactionId;
				$this->approvalCode = $response->identification->approvalCode;
				$this->request_error = 0;
			}
					
			$fp = fopen(dirname(__FILE__).'/soap_response1.txt', 'w');
			fwrite($fp, var_export( $this->card_type, true ));
			fwrite($fp, var_export( $_POST, true ));
			fwrite($fp, var_export( $response, true ));
			fclose($fp);
					
		}
		catch(SoapFault $soapFault) {
			// Log the error
			error_log('factor4gift: inner_make_call()...SoapFault ' . var_dump($soapFault));
			$fp = fopen(dirname(__FILE__).'/soap_fault1.txt', 'w');
			fwrite($fp, var_export( $soapFault, true ));			 
			fclose($fp);
					
			$fault = str_replace($_SERVER['DOCUMENT_ROOT'], '', $soapFault);
			$this->request_error = 1;
		}
	}
}

// initiate settings
add_Action( 'init', 'wrw_init_settings', 100000000 );
function wrw_init_settings(){
	global $settings, $current_user;
	pointsManipulations::drop_unused_coupons(); 
 
}


add_action( 'woocommerce_edit_account_form', 'wrw_favorite_color_to_edit_account_form' );
function wrw_favorite_color_to_edit_account_form() {
    $user = wp_get_current_user();
    ?>
    <p class="woocommerce-form-row woocommerce-form-row--wide form-row form-row-wide">
        <label for="card_type"><?php _e( 'Card Type', 'wrw' ); ?>
        <select name="card_type">
			<option value="loyalty" <?php if( $user->card_type == 'loyalty' ) echo ' selected ';  ?> ><?php echo __('Loyalty', 'wrw'); ?>
			<option value="gift" <?php if( $user->card_type == 'gift' ) echo ' selected ';  ?>><?php echo __('Gift', 'wrw'); ?>
		</select>
	 
    </p>
	<p class="woocommerce-form-row woocommerce-form-row--wide form-row form-row-wide">
        <label for="card_number"><?php _e( 'User Card Number', 'wrw' ); ?>
        <input type="text" class="woocommerce-Input woocommerce-Input--text input-text" name="card_number" id="card_number" value="<?php echo esc_attr( $user->card_number ); ?>" />
    </p>
	 <p class="woocommerce-form-row woocommerce-form-row--wide form-row form-row-wide">
        <label for="card_pin"><?php _e( 'User Card Pin', 'wrw' ); ?>
        <input type="text" class="woocommerce-Input woocommerce-Input--text input-text" name="card_pin" id="card_pin" value="<?php echo esc_attr( $user->card_pin ); ?>" />
    </p>
    <?php
}

// Save the custom fields in my account
add_action( 'woocommerce_save_account_details', 'wrw_save_coount_credentials', 12, 1 );
function wrw_save_coount_credentials( $user_id ) {
    
/*
	if( ( isset( $_POST['card_number'] ) && !isset( $_POST['card_pin'] ) )  
		|| 
		( !isset( $_POST['card_number']) && isset( $_POST['card_pin'] ) ) 
	){
		wc_add_notice( __( 'Please enter card number and PIN' ), 'error' );
		return true;
	}
	*/
	
	// For Billing email (added related to your comment)
    if( isset( $_POST['card_pin'] ) )
        update_user_meta( $user_id, 'card_pin', sanitize_text_field( $_POST['card_pin'] ) );
	
	// For Favorite color
    if( isset( $_POST['card_number'] ) )
        update_user_meta( $user_id, 'card_number', sanitize_text_field( $_POST['card_number'] ) );

    // For Billing email (added related to your comment)
    if( isset( $_POST['card_type'] ) )
        update_user_meta( $user_id, 'card_type', sanitize_text_field( $_POST['card_type'] ) );
}


// on order complete apply points
add_action( 'woocommerce_order_status_completed', 'wrw_woocommerce_order_status_completed', 10, 1 );
function wrw_woocommerce_order_status_completed( $order_id ) {   
  
	$object = new pointsManipulations( 'LoyaltyIssuance', $order_id  );
	$object->card_type = get_post_meta( $order_id, 'card_type', true );
	$object->card_number = get_post_meta( $order_id, 'card_number', true );
	$object->card_pin = get_post_meta( $order_id, 'card_pin', true );
	$object->request_type = 'POINTS';
	$object->make_request();		
	update_post_meta( $order_id, 'pointsTransactionId', $object->transactionId );
	
}

// on refund redeem points from card
add_action( 'woocommerce_refund_created', 'wrw_woocommerce_refund_created', 10, 1 );
function wrw_woocommerce_refund_created( $order_id ) {   
	global $wpdb;
	

	//remove order items
	if( $_POST['restock_refunded_items'] == 'true' ){
		$total_summ = 0;
		$refonded_units = (array)json_decode( stripslashes( $_POST['line_item_qtys'] ) );
		if( count( $refunded_units ) > 0 ){
			foreach( $refunded_units as $id => $qty ){
				$product_id = $wpdb->get_var("
				SELECT ID FROM {$wpdb->prefix}posts WHERE post_title = (SELECT order_item_name FROM {$wpdb->prefix}woocommerce_order_items
 WHERE order_item_id = $id ) ");
 
				$_product = wc_get_product( $product_id );
				$prod_price = $_product->get_price();
 
				$total_summ  = $total_summ  + (float)$prod_price * (int)$qty;
			}
			
			// get product coupon
			$order_id = get_post( $order_id )->post_parent;
			$order = new WC_Order( $order_id );
			$coupons = $order->get_used_coupons();
			

			if( count($coupons) > 0 ){
				foreach( $coupons as $single_coupon_code ){
					$coupon_id = wc_get_coupon_id_by_code($single_coupon_code ) ;
					$coupon_code_old = $single_coupon_code;
				}
			}
			
			
			
			$coupon_amount = (float)get_post_meta( $coupon_id, 'coupon_amount', true );
			
			// check if coupon amount >< refund amount
			/*
			$fp = fopen(dirname(__FILE__).'/partial_refund.txt', 'w');
			fwrite($fp, var_export( $order_id, true ));
			fwrite($fp, "\n");
			fwrite($fp, var_export( $coupon_id, true ));
			fwrite($fp, "\n");
			fwrite($fp, var_export( $coupon_amount, true ));
			fwrite($fp, "\n");
			fwrite($fp, var_export( $total_summ, true ));
			fwrite($fp, "\n");
			fwrite($fp, var_export( $refunded_units, true ));
			fwrite($fp, "\n");
			fclose($fp);

			die();
			*/

			if( $total_summ >= $coupon_amount ){
				$object = new pointsManipulations( 'GiftIssuance', false, $coupon_amount  );
				$object->card_type = get_post_meta( $order_id, 'card_type', true );
				$object->card_number = get_post_meta( $order_id, 'card_number', true );
				$object->card_pin = get_post_meta( $order_id, 'card_pin', true );
				$object->make_request();
				$order->remove_coupon( $coupon_code_old );
			}
			if( $total_summ < $coupon_amount ){
				
				// calculate difference
				$difference = $coupon_amount - $total_summ;
				
				// remove whole summ
				$object = new pointsManipulations( 'GiftIssuance', false, $coupon_amount  );
				$object->card_type = get_post_meta( $order_id, 'card_type', true );
				$object->card_number = get_post_meta( $order_id, 'card_number', true );
				$object->card_pin = get_post_meta( $order_id, 'card_pin', true );
				$object->make_request();
				//wp_delete_post( $coupon_id, true );
				
				
				// make new coupon
				$object = new pointsManipulations( 'GiftRedemption', false, $difference  );
		
				$object->card_type = get_post_meta( $order_id, 'card_type', true );
				$object->card_number = get_post_meta( $order_id, 'card_number', true );
				$object->card_pin = get_post_meta( $order_id, 'card_pin', true );;
				
				$object->make_request();
		 
				$fp = fopen(dirname(__FILE__).'/partial_refund_trace.txt', 'w');
			fwrite($fp, var_export( $object->request_error, true ));
			fwrite($fp, "\n");
	 
		 
		 
				if( $object->request_error == 0 ){
					$coupon_code = 'F4_Reward_Coupon_'.substr($object->card_number, -4).'_'.substr( md5( time() ), 0, 5  );
					
					if( $object->card_type == 'loyalty' ){
						$coupon_content = 'loyalty_card_type';
					}
					if( $object->card_type == 'gift' ){
						$coupon_content = 'gift_card_type';
					}
					
					$args = array(
						'post_type' => 'shop_coupon',
						'post_content' => $coupon_content,
						'post_status' => 'publish',
						'post_name' => $coupon_code,
						'post_title' => $coupon_code,
						
					);
					
					
					fwrite($fp, var_export( $args, true ));
					fwrite($fp, "\n");
					
					
					fwrite($fp, var_export( $difference, true ));
					fwrite($fp, "\n");
					
					fwrite($fp, var_export( $coupon_code, true ));
					fwrite($fp, "\n");
					
					$new_id = wp_insert_post( $args );
					update_post_meta( $new_id, 'coupon_amount', $difference);
					update_post_meta( $new_id, 'discount_type', "fixed_cart");
					update_post_meta( $new_id, 'individual_use', "no");
					update_post_meta( $new_id, 'usage_limit', "1");
					update_post_meta( $new_id, 'usage_limit_per_user', "0");
					update_post_meta( $new_id, 'limit_usage_to_x_items', "0");
					update_post_meta( $new_id, 'usage_count', "0");
					update_post_meta( $new_id, 'free_shipping', "no");
					
					update_post_meta( $new_id, 'card_type', $object->card_type);
					update_post_meta( $new_id, 'card_number', $object->card_number);
					update_post_meta( $new_id, 'card_pin', $object->card_pin);
					
					
					update_post_meta( $new_id, 'transactionId', $object->transactionId );
					update_post_meta( $new_id, 'approvalCode', $object->approvalCode );
					
				 
					$order->remove_coupon( $coupon_code_old ); 
					$order->apply_coupon( $coupon_code );
					
					fwrite($fp, var_export( $coupon_code_old, true ));
					fwrite($fp, "\n");
					
					
					fclose($fp);
					
					
				}else{
					$this->error_message = $object->request_error_message;
				}
				
				
				
				
				
				
			}

			
	 
			/*
			$object = new pointsManipulations( 'GiftIssuance', false, (int)$total_summ  );
			$object->card_type = get_post_meta( $order_id, 'card_type', true );
			$object->card_number = get_post_meta( $order_id, 'card_number', true );
			$object->card_pin = get_post_meta( $order_id, 'card_pin', true );
			$object->make_request();
			*/
		}
	}

}

// full refund

// refund points added with items buy
add_action( 'woocommerce_order_status_cancelled', 'mysite_woocommerce_order_status_cancelled', 10, 1 );
//add_action( 'woocommerce_order_status_refunded', 'mysite_woocommerce_order_status_cancelled', 10, 1 );
function mysite_woocommerce_order_status_cancelled( $order_id ) {   


	// removing points
	/*
	$object = new pointsManipulations(   );
	$object->card_type = get_post_meta( $order_id, 'card_type', true );
	$object->card_number = get_post_meta( $order_id, 'card_number', true );
	$object->card_pin = get_post_meta( $order_id, 'card_pin', true );
	*/
	//$object->transactionId = get_post_meta( $order_id, 'pointsTransactionId', true );
	//$object->make_request();
	
	$object = new pointsManipulations(   );
	
	$object->remove_order_coupons( $order_id );

}

// shoot both
//add_action( 'woocommerce_order_refunded', 'action_woocommerce_order_refunded', 10, 2 ); 
// Do the magic
function action_woocommerce_order_refunded( $order_id, $refund_id ) 
{ 
	//$fp = fopen(dirname(__FILE__).'/order_refunded.txt', 'w');			
	//fclose($fp);

	$object = new pointsManipulations(   );
	$object->remove_order_coupons( $order_id );
}


//add_Action('woocommerce_before_add_to_cart_form', 'wrw_woocommerce_before_add_to_cart_form');
function wrw_woocommerce_before_add_to_cart_form( ){
	global $post;
	$user_points = get_post_meta( $post->ID, 'product_points', true );
	if( $user_points && $user_points != '' ){
		echo '<div class="user_points tw-bs4"><div class="alert alert-success">Product points: '.$user_points.'</div></div>';
	}
}


add_action( 'woocommerce_removed_coupon', 'wrw_woocommerce_removed_coupon', 10, 1 ); 
function wrw_woocommerce_removed_coupon( $coupon_code ) { 
	global $wpdb;
	
	$current_coupon = $wpdb->get_var( $wpdb->prepare("SELECT ID  FROM {$wpdb->prefix}posts WHERE post_type = 'shop_coupon' AND post_title = %s ", $coupon_code ) );
    $result = pointsManipulations::refund_coupon( $current_coupon );					
	
	if( $result == 0 ){
		wp_Delete_post( $current_coupon, true );				
	}
	
}; 
 
//add_Action('init', 'ss');
function ss(){
	$order = new WC_Order( 2903 );
	$order->apply_coupon( '555'  );
}

?>