<?php
  require_once(dirname(__FILE__) . '/SparkbaseTransV4Classes.php');
  //require_once(dirname(__FILE__) . '/config.php');

  // Request Methods
  function CreateRequest() {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateRequest()');
    if ($_POST["method"] == "Adjustment") {
      $request = new Adjustment();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      $request->amount = CreateAmount();
      if (isset($_POST['note'])) {
        $request->note = $_POST['note'];
      }
      return $request;
    }
    else if ($_POST["method"] == "Annotate") {
      $request = new Annotate();
      $request->standardHeader = CreateStandardHeader();
      if (isset($_POST['transactionId'])) {
        $request->transactionId = $_POST['transactionId'];
      }
      if (isset($_POST['note'])) {
        $request->note = $_POST['note'];
      }
      return $request;
    }
    else if ($_POST["method"] == "Inquiry") {
      $request = new Inquiry();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      return $request;
    }
    else if ($_POST["method"] == "AccountHistory") {
      $request = new AccountHistory();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      $request->report = CreateReport();
      return $request;
    }
    else if ($_POST["method"] == "EmployeeReport") {
      $request = new EmployeeReport();
      $request->standardHeader = CreateStandardHeader();
      if (isset($_POST["employeeId"])) {
        $request->reportOnEmployeeId = $_POST["employeeId"];
      }
      $request->report = CreateReport();
      return $request;
    }
    else if ($_POST["method"] == "TerminalReport") {
      $request = new TerminalReport(true);
      $request->standardHeader = CreateStandardHeader();
      $request->report = CreateReport();
      return $request;
    }
    else if ($_POST["method"] == "GiftIssuance") {
      $request = new GiftIssuance();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->amount = CreateAmount();
      $request->promotionCodes = CreatePromotionCodes();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "GiftRedemption") {
      $request = new GiftRedemption();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->amount = CreateAmount();
      if (isset($_POST["includeTip"])) {
        $request->includeTip = $_POST["includeTip"];
      }
      if (isset($_POST["cashOut"])) {
        $request->cashOut = $_POST["cashOut"];
      }
      $request->promotionCodes = CreatePromotionCodes();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "Enrollment") {
      $request = new Enrollment();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      $request->linkToAccount = CreateAccount(true);
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->amount = CreateAmount();
      $request->promotionCodes = CreatePromotionCodes();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "LookUp") {
      $request = new LookUp();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      return $request;
    }
    else if ($_POST["method"] == "LoyaltyIssuance") {
      $request = new LoyaltyIssuance();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->amount = CreateAmount();
      $request->promotionCodes = CreatePromotionCodes();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "LoyaltyRedemption") {
      $request = new LoyaltyRedemption();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->amount = CreateAmount();
      $request->promotionCodes = CreatePromotionCodes();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "PromotionIssuance") {
      $request = new PromotionIssuance();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->amount = CreateAmount();
      $request->promotionCodes = CreatePromotionCodes();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "PromotionRedemption") {
      $request = new PromotionRedemption();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->amount = CreateAmount();
      $request->promotionCodes = CreatePromotionCodes();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "MerchandiseReturn") {
      $request = new MerchandiseReturn();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->amount = CreateAmount();
      $request->promotionCodes = CreatePromotionCodes();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "MultipleIssuance") {
      $request = new MultipleIssuance();
      $request->standardHeader = CreateStandardHeader();
      $request->multipleIssuance = CreateMultipleIssuanceComponent();
      $request->amount = CreateAmount();
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->promotionCodes = CreatePromotionCodes();
      return $request;
    }
    else if ($_POST["method"] == "Hold") {
      $request = new Hold();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      $request->amount = CreateAmount();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "HoldRedemption") {
      $request = new HoldRedemption();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      $request->amount = CreateAmount();
      if (isset($_POST["leaveHeld"])) {
        $request->leaveHeld = $_POST["leaveHeld"];
      }
      if (isset($_POST["holdTransactionId"])) {
        $request->transactionId = $_POST["holdTransactionId"];
      }
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "HoldReturn") {
      $request = new HoldReturn();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      $request->amount = CreateAmount();
      if (isset($_POST["holdTransactionId"])) {
        $request->transactionId = $_POST["holdTransactionId"];
      }
      return $request;
    }
    else if ($_POST["method"] == "QuickTransaction") {
      $request = new QuickTransaction();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["quickCode"])) {
        $request->quickCode = $_POST["quickCode"];
      }
      return $request;
    }
    else if ($_POST["method"] == "Transfer") {
      $request = new Transfer();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["activating"])) {
        $request->activating = $_POST["activating"];
      }
      $request->transfer = CreateTransferComponent();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "Renew") {
      $request = new Renew();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      if (isset($_POST["newExpirationDate"])) {
        $request->newExpirationDate = $_POST["newExpirationDate"];
      }
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      $request->customerInfo = CreateCustomerInfo();
      return $request;
    }
    else if ($_POST["method"] == "Tip") {
      $request = new Tip();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      $request->search = CreateSearch();
      $request->amount = CreateAmount();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      return $request;
    }
    else if ($_POST["method"] == "VoidTransaction") {
      $request = new VoidTransaction();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      $request->search = CreateSearch();
      $request->questionsAndAnswers = CreateQuestionsAndAnswers();
      return $request;
    }
    else if ($_POST["method"] == "Deactivate") {
      $request = new VoidTransaction();
      $request->standardHeader = CreateStandardHeader();
      $request->account = CreateAccount();
      return $request;
    }
  }

  // Create Parts
  function CreateStandardHeader($close = false) {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateStandardHeader()');
    $requestId = 0;
    $batchId = 1;
    $batchReference = 1;
    $lastTransDate = date('Ymd', $_SERVER['REQUEST_TIME']);

    try {
      $reqBat = file(REQ_BAT_PATH, FILE_IGNORE_NEW_LINES);
      $requestId = $reqBat[0];
      $batchId = $reqBat[1];
      $batchReference = $reqBat[2];
      $lastTransDate = $reqBat[3];
      unset($reqBat);
      // TO DO: Only increment request id after response is received (even if
      //  rejected)
      // TO DO: Roll over if exceeds max
      $requestId += 1;

      if (date('Ymd', $_SERVER['REQUEST_TIME']) > $lastTransDate) {
        $batchId += 1;
        $batchReference = 1;
      }
      else {
        // TO DO: Only increment batch ref when approval response is received
        //  and is not a duplicate
        $batchReference += 1;
      }
      if (2176782335 < $requestId) {
        $requestId = 0;
      }
      if (999999 < $batchReference) {
        $batchId += 1;
        $batchReference = 1;
      }
      if ((999999 < $batchId) || ($close)) {
        $batchId = 1;
        $batchReference = 1;
      }
    }
    catch (Exception $e) {
      error_log('factor4gift: Error reading from ' . var_export(REQ_BAT_PATH, true));
    }

    try {
      $reqBat = fopen(REQ_BAT_PATH, 'w');
      $stringData = $requestId . "\n"
        . $batchId . "\n"
        . $batchReference . "\n"
        . date('Ymd', $_SERVER['REQUEST_TIME']);
      fwrite($reqBat, $stringData);
      fclose($reqBat);
    }
    catch (Exception $e) {
      error_log('factor4gift: Error writing to ' . var_export(REQ_BAT_PATH, true));
    }

    $part = new StandardHeader();
    $part->requestId = strtoupper(base_convert($requestId, 10, 36));
    $part->localeId = LOCALE_ID;
    $part->systemId = SYSTEM_ID;
    $part->clientId = CLIENT_ID;
    $part->locationId = LOCATION_ID;
    $part->terminalId = TERMINAL_ID;
    $part->terminalDateTime = date("YmdHis");
    $part->initiatorType = INITIATOR_TYPE;
    $part->initiatorId = INITIATOR_ID;
    $part->initiatorPassword = INITIATOR_PASSWORD;
    $part->externalId = '';
    $part->batchId = $batchId;
    $part->batchReference = $batchReference;
    error_log('factor4gift: -SparkbaseTransV4Util.CreateStandardHeader() ' . serialize($part));
    return $part;
  }

  function CreateAccount($isLinkTo = false) {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateAccount()');
    $part = new Account();
    if (isset($_POST["programId"])) {
      $part->programId = $_POST["programId"];
    }
    if ($isLinkTo) {
      if (isset($_POST["linkToAccountId"])) {
        $part->accountId = $_POST["linkToAccountId"];
      }
      if (isset($_POST["linkToAccountIdType"])) {
        $part->accountIdType = $_POST["linkToAccountIdType"];
      }
      if (isset($_POST["linkToPin"])) {
        $part->pin = $_POST["linkToPin"];
      }
      if (isset($_POST["linkToEntryType"])) {
        $part->entryType = $_POST["linkToEntryType"];
      }
    }
    else {
      if (isset($_POST["accountId"])) {
        $part->accountId = $_POST["accountId"];
      }
      if (isset($_POST["accountIdType"])) {
        $part->accountIdType = $_POST["accountIdType"];
      }
      if (isset($_POST["pin"])) {
        $part->pin = $_POST["pin"];
      }
      if (isset($_POST["entryType"])) {
        $part->entryType = $_POST["entryType"];
      }
    }
    error_log('factor4gift: -SparkbaseTransV4Util.CreateAccount() ' . serialize($part));
    return $part;
  }

  function CreateCustomerInfo() {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateCustomerInfo()');
    $part = new CustomerInfo();
    if (isset($_POST["customerType"])) {
      $part->customerType = $_POST["customerType"];
    }
    if (isset($_POST["firstName"])) {
      $part->firstName = $_POST["firstName"];
    }
    if (isset($_POST["middleName"])) {
      $part->middleName = $_POST["middleName"];
    }
    if (isset($_POST["lastName"])) {
      $part->lastName = $_POST["lastName"];
    }
    if (isset($_POST["address1"])) {
      $part->address1 = $_POST["address1"];
    }
    if (isset($_POST["address2"])) {
      $part->address2 = $_POST["address2"];
    }
    if (isset($_POST["city"])) {
      $part->city = $_POST["city"];
    }
    if (isset($_POST["state"])) {
      $part->state = $_POST["state"];
    }
    if (isset($_POST["postal"])) {
      $part->postal = $_POST["postal"];
    }
    if (isset($_POST["country"])) {
      $part->country = $_POST["country"];
    }
    if (isset($_POST["mailPref"])) {
      $part->mailPref = $_POST["mailPref"];
    }
    if (isset($_POST["phone"])) {
      $part->phone = $_POST["phone"];
    }
    if (isset($_POST["isMobile"])) {
      $part->isMobile = $_POST["isMobile"];
    }
    if (isset($_POST["phonePref"])) {
      $part->phonePref = $_POST["phonePref"];
    }
    if (isset($_POST["email"])) {
      $part->email = $_POST["email"];
    }
    if (isset($_POST["emailPref"])) {
      $part->emailPref = $_POST["emailPref"];
    }
    if (isset($_POST["birthday"])) {
      $part->birthday = $_POST["birthday"];
    }
    if (isset($_POST["anniversary"])) {
      $part->anniversary = $_POST["anniversary"];
    }
    if (isset($_POST["gender"])) {
      $part->gender = $_POST["gender"];
    }
    error_log('factor4gift: -SparkbaseTransV4Util.CreateCustomerInfo() ' . serialize($part));
    return $part;
  }

  function CreateMultipleIssuanceComponent() {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateMultipleIssuanceComponent()');
    $part = new MultipleIssuanceComponent();
    if (isset($_POST["specified"])) {
      $part->specifiedBy = $_POST["specified"];
    }
    $accounts;
    $count = 0;
    if (isset($_POST["MultipleIssuanceAccountCount"])) {
      $count = $_POST["MultipleIssuanceAccountCount"];
    }
    for ($i = 0; $i < $count; $i++) {
      if ("" != $_POST["multipleIssuanceAccountId".$i]) {
        $account = array("accountId" => $_POST["multipleIssuanceAccountId".$i],
          "pin" => $_POST["multipleIssuancePin" . $i],
          "entryType" => $_POST["multipleIssuanceEntryType" . $i] );
        $accounts[] = $account;
      }
    }
    $part->accounts = $accounts;
    error_log('factor4gift: -SparkbaseTransV4Util.CreateMultipleIssuanceComponent() ' . serialize($part));
    return $part;
  }

  function CreateReport() {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateReport()');
    $part = new Report();
    if (isset($_POST["reportType"])) {
      $part->type = $_POST["reportType"];
    }
    if (isset($_POST["minimumDate"])) {
      $part->minimumDate = $_POST["minimumDate"];
    }
    if (isset($_POST["maximumDate"])) {
      $part->maximumDate = $_POST["maximumDate"];
    }
    if (isset($_POST["offset"])) {
      $part->offset = $_POST["offset"];
    }
    if (isset($_POST["maxRecords"])) {
      $part->maxRecords = $_POST["maxRecords"];
    }
    error_log('factor4gift: -SparkbaseTransV4Util.CreateReport() ' . serialize($part));
    return $part;
  }

  function CreateSearch() {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateSearch()');
    $part = new Search();
    if (isset($_POST["batchId"])) {
      $part->batchId = $_POST["batchId"];
    }
    if (isset($_POST["batchReference"])) {
      $part->batchReference = $_POST["batchReference"];
    }
    if (isset($_POST["transactionId"])) {
      $part->transactionId = $_POST["transactionId"];
    }
    if (isset($_POST["approvalCode"])) {
      $part->approvalCode = $_POST["approvalCode"];
    }
    error_log('factor4gift: -SparkbaseTransV4Util.CreateSearch() ' . serialize($part));
    return $part;
  }

  function CreateTransferComponent() {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateTransferComponent()');
    $part = new TransferComponent();
    if (isset($_POST["destAccountId"])) {
      $part->destAccountId = $_POST["destAccountId"];
    }
    if (isset($_POST["destPin"])) {
      $part->destPin = $_POST["destPin"];
    }
    if (isset($_POST["destEntryType"])) {
      $part->destEntryType = $_POST["destEntryType"];
    }
    if (isset($_POST["closeReason"])) {
      $part->closeReason = $_POST["closeReason"];
    }
    if (isset($_POST["transferValueCode"])) {
      $part->valueCode = $_POST["transferValueCode"];
    }
    if (isset($_POST["transferEnteredAmount"])) {
      $part->enteredAmount = $_POST["transferEnteredAmount"];
    }
    error_log('factor4gift: -SparkbaseTransV4Util.CreateTransferComponent() ' . serialize($part));
    return $part;
  }

  function CreateAmount() {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateAmount()');
    $part = new Amount();
    if (isset($_POST["valueCode"])) {
      $part->valueCode = $_POST["valueCode"];
    }
    if (isset($_POST["enteredAmount"])) {
      $part->enteredAmount = $_POST["enteredAmount"];
    }
    if (isset($_POST["nsfAllowed"])) {
      $part->nsfAllowed = $_POST["nsfAllowed"];
    }
    error_log('factor4gift: -SparkbaseTransV4Util.CreateAmount() ' . serialize($part));
    return $part;
  }

  function CreatePromotionCodes() {
    error_log('factor4gift: +SparkbaseTransV4Util.CreatePromotionCodes()');
    $promotionCodes = array();
    $count = 0;
    if (isset($_POST["PromotionCodeCount"])) {
      $count = $_POST["PromotionCodeCount"];
    }
    for ($i = 0; $i < $count; $i++) {
      if (! empty($_POST["promotionCode" . $i])) {
        $promotionCode = array("code" => $_POST["promotionCode" . $i],
          "quantity" => $_POST["quantity" . $i]);
        $promotionCodes[] = $promotionCode;
      }
    }
    error_log('factor4gift: -SparkbaseTransV4Util.CreatePromotionCodes() ' . serialize($promotionCodes));
    return $promotionCodes;
  }

  function CreateQuestionsAndAnswers() {
    error_log('factor4gift: +SparkbaseTransV4Util.CreateQuestionsAndAnswers()');
    $questionsAndAnswers = array();
    $count = 0;
    if (isset($_POST["QuestionAndAnswerCount"])) {
      $count = $_POST["QuestionAndAnswerCount"];
    }
    for ($i = 0; $i < $count; $i++) {
      if (! empty($_POST["questionCode" . $i])) {
        $questionAndAnswer = array("code" => $_POST["questionCode" . $i],
          "answer" => $_POST["answer" . $i]);
        $questionCodes[] = $questionAndAnswer;
      }
    }
    error_log('factor4gift: -SparkbaseTransV4Util.CreateQuestionsAndAnswers() ' . serialize($questionsAndAnswers));
    return $questionsAndAnswers;
  }

  // Transaction Methods
  function SendRequest() {
    error_log('factor4gift: +SparkbaseTransV4Util.SendRequest()');
    // Create the request from the post
    $request = CreateRequest();
	
    // Consider: use class map option to map the data to a useable form
    $options = array('trace' => true,
      'login' => INTEGRATION_USER_NAME,
      'password'=> INTEGRATION_PASSWORD);
    $uri = SPARKBASE_TRANSACTION_WSDL;
    $client = new SoapClient($uri, $options);
    // return $client->$_POST["method"]($request); // Root Cause of issue

    error_log('f4-test-page: Soap Call: ' . print_r($request, true));
    error_log('f4-test-page: $_POST["method"]: ' . print_r($_POST["method"], true));    
    // Convert Request into Array
    $array = array($request);
    $soapReponse = $client->__soapCall($_POST["method"], $array);
    error_log('f4-test-page: soapReponse: ' . print_r($soapReponse, true));    
    return $soapReponse;
  }

  // Response Methods
  function WriteResponse($response) {
    error_log('factor4gift: +SparkbaseTransV4Util.WriteResponse() ' . serialize($response));
    foreach($response as $field => $value) {
      if (($field == "hello") || ($field == "hostMessage")
          || ($field == "expirationDate") || ($field == "amountRemaining")) {
        // Write any parts that are not a component
        echo($field);
        echo(" = ");
        echo($value);
        echo("</BR>");
      }
      else if ($field == "printableData" ) {
        echo($field);
        echo("</BR>");
        echo($value);
      }
      else {
        // Write the name of the component
        echo($field);
        echo("</BR>");
        // Get the parts of the component
        foreach($value as $subfield => $subvalue) {
          // Write the parts of that component
          echo($subfield);
          echo(" = ");
		  if( is_array( $subvalue ) ){
			 serialize( $subvalue );
		  }else{
			echo($subvalue);  
		  }
          
          echo("</BR>");
        }
      }
    }
    error_log('factor4gift: -SparkbaseTransV4Util.WriteResponse()');
  }
?>
